/*
	$Id: About.java 5607 2011-04-15 07:52:28Z nicklas $

	Copyright (C) 2005 Samuel Andersson, Johan Enell
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions;

import java.util.Collection;

import net.sf.basedb.core.plugin.About;

/**
	Adds extra information to the About interface.

	@author Nicklas
	@since 3.3
*/
public interface ExtendedAbout
	extends About
{

	/**
		Get extra information
		@param name The name of the extra information
		@return A value or null if no information is present
	*/
	public String getAttribute(String name);
	
	/**
		Get all extra attribute names.
		@return A collection which may be null or empty
	*/
	public Collection<String> getAttributeNames();
	
}
