<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.DiskUsage"
	import="net.sf.basedb.core.DiskUsageStatistics"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Map"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DISKUSAGE;
	private static final String subContext = "perGroup";
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST, subContext);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final boolean writePermission = sc.hasPermission(Permission.WRITE, Item.GROUP);
final String showStatistics = Values.getString(cc.getSetting("showStatistics"), 
	Application.hasSecondaryStorage() ? "full" : "quotaType");

final boolean hasLocation = "location".equals(showStatistics) || "full".equals(showStatistics);
final boolean hasQuotaType = "quotaType".equals(showStatistics) || "full".equals(showStatistics);

final DbControl dc = sc.newDbControl();
ItemResultIterator<Group> groups = null;
try
{
	DiskUsageStatistics du = (DiskUsageStatistics)sc.getSessionSetting("diskUsageStatistics");
	if (du == null)
	{
		du = DiskUsage.getStatistics(dc);
		sc.setSessionSetting("diskUsageStatistics", du);
	}
	du.setDbControl(dc);
	List<QuotaType> quotaTypes = du.getQuotaTypes();
	
	try
	{
		final ItemQuery<Group> query = Base.getConfiguredQuery(dc, cc, true, Group.getQuery(), mode);
		query.include(Include.ALL);
		query.restrict(
				Restrictions.neq(
					Hql.property("quota"), null));
		groups = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="Disk usage" id="list-groups">
	<base:head scripts="table.js,tabcontrol-2.js,~diskusage.js" styles="table.css,toolbar.css,headertabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		table.special
		{
			border-width: 1px;
			margin: 2px;
			border-collapse: collapse;
			width: calc(100% - 6px);
		}
		table.special td, table.special th
		{
			text-align: right;
			border-right-width: 1px;
			border-right-style: dotted;
			padding: 1px 2px 1px 2px;
		}
		</style>
	</base:head>
	<base:body>
		<h1>Disk usage</h1>
		<t:tabcontrol 
			id="main" 
			subclass="mastertabcontrol content" 
			active="groups">
		<t:tab id="overview" title="Overview" data-cmd="Overview" />
		<t:tab id="users" title="Per user" data-cmd="ListUsers" />
		<t:tab id="groups" title="Per group" data-cmd="ListGroups">
		<tbl:table 
			id="groups" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="subcontext"
				value="<%=subContext%>"
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="diskUsage"
				title="Disk usage summary"
				show="always"
			/>
			<tbl:columndef 
				id="quota"
				property="quota.name"
				datatype="string"
				title="Quota"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					visible="<%=mode.hasToolbar()%>"
					subclass="bottomborder"
					>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=groups == null ? 0 : groups.getTotalCount()%>" 
					/>
					<b>Show summary</b>
					<span id="changeSummary">
					<label><input type="radio" name="showStatistics" value="total"
						<%="total".equals(showStatistics) ? "checked" : ""%>>Total only</label>
					<label><input type="radio" name="showStatistics" value="location"
						<%="location".equals(showStatistics) ? "checked" : ""%>>Per location</label>
					<label><input type="radio" name="showStatistics" value="quotaType"
						<%="quotaType".equals(showStatistics) ? "checked" : ""%>>Per quota type</label>
					<label><input type="radio" name="showStatistics" value="full"
						<%="full".equals(showStatistics) ? "checked" : ""%>>Full</label>
					</span>
				</tbl:panel>
			</div>

			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="index" />
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasCheck()%>"
								><base:icon 
									subclass="link table-check"
									image="check_uncheck.png" 
									tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
									visible="<%=lastRow%>"
								/></tbl:header>
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasRadio()%>"
								/>
							<tbl:header 
								subclass="icons" 
								visible="<%=mode.hasIcons()%>"
								>
								<base:icon
									subclass="link table-filter-row-action"
									image="add.png"
									tooltip="Add extra filter row"
									visible="<%=lastRow%>"
								/><base:icon
									subclass="link table-filter-row-action"
									image="remove.png"
									tooltip="Remove this filter row"
									visible="<%=numRows > 1 || numFilters > 0 %>"
									data-remove-row="<%=filterNo%>"
								/>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (groups != null)
					{						
						while (groups.hasNext())
						{
							Group item = groups.next();
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div 
									class="link auto-init"
									data-auto-init="item-link"
									data-item-type="GROUP"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="diskUsage" style="padding: 0px;">
									<%
									DiskUsageStatistics.Summary summary = du.getSummary(item);
									long total = summary.getTotal();
									if (total > 0 && (hasLocation || hasQuotaType))
									{
										%>
										<table class="special bottomborder">
										<%
										if (hasLocation)
										{
											%>
											<tr class="bottomborder bg-filled-100">
												<%
												if (hasQuotaType)
												{
													%>
													<th></th>
													<%
												}
												%>
												<th>Total</th>
												<td>Primary</td>
												<td>Secondary</td>
												<td>Offline</td>
												<td>External</td>
											</tr>
											<%
										}
										%>	
										<tr class="bottomborder <%=!hasLocation ? "bg-filled-100" : "" %>">
											<%
											if (hasQuotaType)
											{
												%>
												<th>Total</th>
												<%
											}
											%>
											<td><%=Values.formatBytes(total)%></td>
											<%
											if (hasLocation)
											{
												%>
												<td><%=Values.formatBytes(summary.getTotal(Location.PRIMARY))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.SECONDARY))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.OFFLINE))%></td>
												<td><%=Values.formatBytes(summary.getTotal(Location.EXTERNAL))%></td>
												<%
											}
											%>
										</tr>	
										<%
										if (hasQuotaType && total > 0)
										{
											for (QuotaType qt : quotaTypes)
											{
												%>
												<tr>
													<td><%=HTML.encodeTags(qt.getName())%></td>
													<td><%=Values.formatBytes(summary.getTotal(qt))%></td>
													<%
													if (hasLocation)
													{
														%>
														<td><%=Values.formatBytes(summary.getTotal(qt, Location.PRIMARY))%></td>
														<td><%=qt.hasSecondaryLocation() ? Values.formatBytes(summary.getTotal(qt, Location.SECONDARY)) : "n/a"%></td>
														<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.OFFLINE)) : "n/a"%></td>
														<td><%=qt.getSystemId().equals(QuotaType.FILE) ? Values.formatBytes(summary.getTotal(qt, Location.EXTERNAL)) : "n/a"%></td>
														<%
													}
													%>
												</tr>
												<%
											}
										}
										%>
										</table>
										<%
									}
									else
									{
										%>
										&nbsp;<%=Values.formatBytes(total)%>
										<%
									}
									if (total > 0)
									{
										%>
										<base:icon image="gonext.png" 
											subclass="link auto-init"
											data-auto-init="view-details"
											data-item-type="GROUP"
											data-item-id="<%=itemId %>">View details</base:icon>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="quota"
									><base:propertyvalue 
										item="<%=item%>" 
										property="quota"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
						if (numListed == 0)
						{
							%>
							<tbl:panel subclass="bg-filled-50">
								<div class="messagecontainer note">
								<%=groups == null || groups.getTotalCount() == 0 ? "No groups were found" : "No groups on this page. Please select another page!" %>
								</div>
							</tbl:panel>
							<%
						}
						%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (groups != null) groups.close();
	if (dc != null) dc.close();
}
%>
