<%-- $Id: index.jsp 6696 2015-01-28 08:23:03Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ReporterCloneTemplate"
	import="net.sf.basedb.core.ReporterCloneBatcher"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.plugins.CloneReportersPlugin"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.Arrays"
	import="java.util.ArrayList"
	import="java.util.Collections"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,rawDataType,description,actions");
	private static final Item itemType = Item.EXPERIMENT;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_experiments.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_experiment.jsp?ID="+ID;
final String editPage = "edit_experiment.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;
try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl();
		
		Experiment experiment = (Experiment)cc.getObject("item");
		if (experiment == null)
		{
			RawDataType rdt = RawDataTypes.getRawDataType(Values.getStringOrNull(request.getParameter("rawdatatype")));
			if (rdt != null) cc.setRecent("RawDataType", rdt.getId(), maxRecent);
			experiment = Experiment.getNew(dc, rdt);
			message = "Experiment created";
			dc.saveItem(experiment);
		}
		else
		{
			dc.reattachItem(experiment, false);
			message = "Experiment updated";
		}

		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.EXPERIMENT), experiment);
		ExtensionsInvoker invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
			experiment.setName(Values.getStringOrNull(request.getParameter("name")));
			experiment.setTitle(Values.getStringOrNull(request.getParameter("title")));
			experiment.setAbstract(Values.getStringOrNull(request.getParameter("abstract")));
			experiment.setAffiliations(Values.getStringOrNull(request.getParameter("affiliations")));
			experiment.setAuthors(Values.getStringOrNull(request.getParameter("authors")));
			experiment.setExperimentDesign(Values.getStringOrNull(request.getParameter("experimentDesign")));
			experiment.setExperimentType(Values.getStringOrNull(request.getParameter("experimentType")));
			experiment.setPublication(Values.getStringOrNull(request.getParameter("publication")));
			experiment.setPublicationDate(dateFormatter.parseString(Values.getStringOrNull(request.getParameter("publicationDate"))));
			experiment.setPubMedId(Values.getStringOrNull(request.getParameter("pubMedId")));
			experiment.setDescription(Values.getStringOrNull(request.getParameter("description")));
	
			int directoryId = Values.getInt(request.getParameter("directory_id"), -1);
			if (directoryId >= 0) // < 0 = denied or unchanged
			{
				Directory dir = directoryId == 0 ? null : Directory.getById(dc, directoryId);
				experiment.setDirectory(dir);
				if (dir != null) cc.setRecent(dir, maxRecent);
			}
	
			String[] removeRawBioAssays = Values.getString(request.getParameter("-RAWBIOASSAY")).split(",");
			for (int i = 0; i < removeRawBioAssays.length; ++i)
			{
				int rawBioAssayId = Values.getInt(removeRawBioAssays[i], -1);
				if (rawBioAssayId != -1) experiment.removeRawBioAssay(RawBioAssay.getById(dc, rawBioAssayId));
			}
			
			String[] addRawBioAssays = Values.getString(request.getParameter("+RAWBIOASSAY")).split(",");
			for (int i = 0; i < addRawBioAssays.length; ++i)
			{
				int rawBioAssayId = Values.getInt(addRawBioAssays[i], -1);
				if (rawBioAssayId != -1) experiment.addRawBioAssay(RawBioAssay.getById(dc, rawBioAssayId));
			}
			
			String[] removeAnnotationTypes = Values.getString(request.getParameter("-ANNOTATIONTYPE")).split(",");
			for (int i = 0; i < removeAnnotationTypes.length; ++i)
			{
				int annotationTypeId = Values.getInt(removeAnnotationTypes[i], -1);
				if (annotationTypeId != -1) experiment.removeExperimentalFactor(AnnotationType.getById(dc, annotationTypeId));
			}
			
			String[] addAnnotationTypes = Values.getString(request.getParameter("+ANNOTATIONTYPE")).split(",");
			for (int i = 0; i < addAnnotationTypes.length; ++i)
			{
				int annotationTypeId = Values.getInt(addAnnotationTypes[i], -1);
				if (annotationTypeId != -1) experiment.addExperimentalFactor(AnnotationType.getById(dc, annotationTypeId));
			}
			
			// Annotations tab
			Base.updateAnnotations(dc, experiment, experiment, request);

			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.removeRecursively(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int[] numRemoved = RemovableUtil.removeRecursively(dc, itemType, cc.getSelected(), true);
		numTotal += numRemoved[1];
		dc.commit();
		if (numTotal != numRemoved[0])
		{
			message = (numRemoved[0] == 0 ? "No" : "Only "+numRemoved[0]+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage;
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.removeRecursively(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int[] numRemoved = RemovableUtil.removeRecursively(dc, itemType, cc.getSelected(), false);
		numTotal += numRemoved[1];
		dc.commit();
		if (numTotal != numRemoved[0])
		{
			message = (numRemoved[0] == 0 ? "No" : "Only "+numRemoved[0]+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl();
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Experiment> query = Experiment.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		cc.setQuery(query);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		ExtensionsInvoker listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+experiments";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+experiment";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Experiment> query = Experiment.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+experiments";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+experiment";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<Experiment> query = Experiment.getQuery();
		dc = sc.newDbControl();
		cc.configureQuery(dc, query, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("AutoInherit".equals(cmd))
	{
		Integer[] annotationTypeIds = Values.getInt(request.getParameterValues("autoinherit"));
		if (annotationTypeIds.length > 0)
		{
			dc = sc.newDbControl();
			Set<AnnotationType> annotationTypes = new HashSet<AnnotationType>(annotationTypeIds.length);
			for (int atId : annotationTypeIds)
			{
				annotationTypes.add(AnnotationType.getById(dc, atId));
			}
			
			Experiment exp = Experiment.getById(dc, Values.getInt(itemId));
			ItemQuery<RawBioAssay> query = exp.getRawBioAssays();
			query.include(Include.ALL);
			query.setItemPermission(Permission.WRITE);

			List<RawBioAssay> all = query.list(dc);
			ItemContext rawContext = sc.getCurrentContext(Item.RAWBIOASSAY);
			rawContext.setObject("AnnotatedItems", new HashSet(all));
			rawContext.setObject("AnnotationTypes", annotationTypes);
			redirect = "../../common/annotations/batch_inherit.jsp?ID="+ID+"&item_type=RAWBIOASSAY";
		}
	}
	else if ("CloneReporters".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		
		dc = sc.newDbControl();
		int templateId = Values.getInt(request.getParameter("reporterclonetemplate_id"));
		ReporterCloneTemplate template = null;
		if (templateId > 0)
		{
			template = ReporterCloneTemplate.getById(dc, templateId);
			cc.setRecent(template, maxRecent);
		}
		
		Experiment exp = Experiment.getById(dc, Values.getInt(itemId));
		
		PluginDefinition clonePlugin = PluginDefinition.getByClassName(dc, CloneReportersPlugin.class.getName());
		Job cloneJob = Job.getNew(dc, clonePlugin, null, exp);
		if (template == null)
		{
			cloneJob.setName("Cloning all reporter properties");
		}
		else
		{
			cloneJob.setName("Cloning reporters using template '" + template.getName() + "'");
		}
		cloneJob.setDescription(Values.getStringOrNull(request.getParameter("description")));
		cloneJob.setParameterValue("template", "Reporter clone template", null, 
			new ItemParameterType<ReporterCloneTemplate>(ReporterCloneTemplate.class, null), template);
		cloneJob.setParameterValue("cloneSource", "Clone source", null, 
			new StringParameterType(), request.getParameter("cloneSource"));
		cloneJob.setScheduled(null, null);
		dc.saveItem(cloneJob);
		dc.commit();
		
		redirect = "../jobs/index.jsp?ID=" + ID + "&cmd=ViewItem&item_id="+cloneJob.getId();
	}
	else if ("RemoveClonedReporters".equals(cmd))
	{
		
		dc = sc.newDbControl();
		Experiment exp = Experiment.getById(dc, Values.getInt(itemId));
		ReporterCloneBatcher batcher = exp.getReporterCloneBatcher(dc);
		batcher.dropClonedReporters();
		dc.commit();
		
		message = "The cloned reporter annotations has been removed";
		
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

